#include "Star.h"

#include <iostream>

StationarySprite::StationarySprite(const sf::Texture& texture, float ypos)
    : sprite(texture),
      position(50.0f+.8f*(rand() % static_cast<int>(BackgroundSize.x)),
               static_cast<float>( rand() % static_cast<int>(BackgroundSize.y * ypos + 50.0f)))
{
    sprite.setScale(0.3f,0.3f);
    sprite.setOrigin(sprite.getLocalBounds().width/2.0f,sprite.getLocalBounds().height / 2.0f);
    sprite.setPosition(position);
    sprite.rotate(90.0f * (position.x/BackgroundSize.x-0.33f));
}

void StationarySprite::move(Direction direction)
{
    // Move sprite 5% of window size
    switch (direction)
    {
    case Up:
        sprite.setPosition(sprite.getPosition().x, sprite.getPosition().y - 0.05f * BackgroundSize.y);
        if (sprite.getPosition().y < 0.0f)
            sprite.setPosition(sprite.getPosition().x,BackgroundSize.y - 1.0f);
        break;
    case Down:
        sprite.setPosition(sprite.getPosition().x, sprite.getPosition().y + 0.05f * BackgroundSize.y);
        if (sprite.getPosition().y > BackgroundSize.y)
            sprite.setPosition(sprite.getPosition().x, 1.0f);
        break;
    case Left:
        sprite.setPosition(sprite.getPosition().x - 0.05f * BackgroundSize.x,sprite.getPosition().y);
        if (sprite.getPosition().x < 0.0f)
            sprite.setPosition(BackgroundSize.x - 1.0f,sprite.getPosition().y);
        break;
    case Right:
        sprite.setPosition(sprite.getPosition().x + 0.05f * BackgroundSize.x,sprite.getPosition().y);
        if (sprite.getPosition().x > BackgroundSize.x)
            sprite.setPosition(1.0f,sprite.getPosition().y);
        break;
    default:
        ;
    };
}
